Skip to main content

Sweep Line - Question 3

1674. Minimum Moves to Make Array Complementary

You are given an integer array nums of even length n and an integer limit. In one move, you can replace any integer from nums with another integer between 1 and limit, inclusive.

The array nums is complementary if for all indices i (0-indexed), nums[i] + nums[n - 1 - i] equals the same number. For example, the array [1,2,3,4] is complementary because for all indices i, nums[i] + nums[n - 1 - i] = 5.

Return the minimum number of moves required to make nums complementary.

Constraints:

n == nums.length

2 <= n <= 10^5

1 <= nums[i] <= limit <= 10^5

n is even.


Analysis:

The brute force method works, for example, the pair sum range is [2, limit*2], so we can check the number of replacements needed for each sum, then pick up the smallest one. But the time complexity is O(N*limit), which could be as high as 10^10!

So we need to find a faster method to pass the OJ.

A faster algorithm is NOT easy to find, if do not have a good understanding about Sweep Line algorithm.

For example, the binary search does not work here, since the optimal pair sum could be more than one. One of the difficulties is the optimal sum is not known.

Some key observations:

1. the pair sum range is [2, limit*2];

2. for each pair a + b = c, the above range can be divided into different intervals base on the number of replacements (to make their sum equals to c):

a. [2, min(a, b)]. In this range, we have to do the replacement for both numbers to make their sum to be c. Remember, for one replacement, we can only replace a number in the range of [1, limit];

b. [min(a, b)+1, a+b-1], needs 1 replacement;

c. [a+b, a+b], needs 0 replacement;

d. [a+b+1, max(a, b) + limit], needs 1 replacement;

e. [max(a, b) + limit + 1, limit*2], needs 2 replacements.


If you have done a similar Sweep Line question previously, then it should be easier to understand the logic here.

One typical feature is that: inside each interval, the number of replacement is the same for one pair sum, which suggests that sweep line algorithm may be a good choice to this question.

The difference here is (compare to a typical Sweep Line question): each pair sum generates 5 intervals (see the above) in the range of [2, limit*2], which makes this question to a hard level.

Two steps:

1. only label the values at the starting and ending for each intervals;

2. after finishing the labeling for all the intervals in step 1, we can do a sweeping scan for all the intervals, to accumulate the replacements needed at each position.

For this question, we need to get the minimum value of it. So we can get the minimum in step 2.


Time complexity: O(max(N, limit))

Space complexity: O(limit)


See the code below:

class Solution {
public:
    int minMoves(vector<int>& nums, int limit) {
        int n = nums.size(), res = n, ct = 0;
        vector<int> data(2*limit+2, 0);
        for(int i=0; i<n/2; ++i) {
            int x = nums[i], y = nums[n-i-1];
            // label the terminals of intervals
            data[2] += 2;
            data[min(x, y) + 1] -= 1;
            data[x+y] -= 1;
            data[x+y+1] += 1;
            data[max(x, y) + limit + 1] += 1;
        }
        for(int i=2; i<2*limit+2; ++i) {
            ct += data[i];
            res = min(res, ct);
        }
        return res;
    }
};


Bonus questions: 

1. can you figure out one sum that gives the optimal (or minimum) replacements?

2. how many sums that can give the optimal replacements?


Upper Layer


Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class